package com.lzmispt.data.resource.service.monitor.impl;

package .tmp;

import com.lzmispt.data.resource.dao.monitor.IMonitoringPlatformDao;
import com.lzmispt.data.resource.entity.po.monitor.DataPushMonitorPO;
import com.lzmispt.data.resource.service.monitor.ICudDataService;
import com.lzmispt.framework.log.LogHelper;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.stream.Collectors;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;

@Service
public class CudDataServiceImpl implements ICudDataService {
  @Autowired
  private IMonitoringPlatformDao iMonitoringPlatformDao;
  
  public List<Long> getDeleteData(List<DataPushMonitorPO> paramData, List<DataPushMonitorPO> dbData) {
    if (CollectionUtils.isEmpty(dbData))
      return new ArrayList<>(); 
    Set<Long> dbIds = (Set<Long>)dbData.stream().map(DataPushMonitorPO::getInterfaceUserId).collect(Collectors.toSet());
    if (CollectionUtils.isEmpty(paramData))
      return new ArrayList<>(dbIds); 
    Set<Long> paramIds = (Set<Long>)paramData.stream().map(DataPushMonitorPO::getInterfaceUserId).collect(Collectors.toSet());
    return (List<Long>)dbIds.stream().filter(item -> !paramIds.contains(item)).collect(Collectors.toList());
  }
  
  public List<DataPushMonitorPO> getUpdateData(List<DataPushMonitorPO> paramData, List<DataPushMonitorPO> dbData) {
    if (CollectionUtils.isEmpty(paramData) || CollectionUtils.isEmpty(dbData))
      return new ArrayList<>(); 
    Set<Long> dbIds = (Set<Long>)dbData.stream().map(DataPushMonitorPO::getInterfaceUserId).collect(Collectors.toSet());
    return (List<DataPushMonitorPO>)paramData.stream().filter(item -> dbIds.contains(item.getInterfaceUserId())).collect(Collectors.toList());
  }
  
  public List<DataPushMonitorPO> getInsertData(List<DataPushMonitorPO> paramData, List<DataPushMonitorPO> dbData) {
    if (CollectionUtils.isEmpty(paramData))
      return new ArrayList<>(); 
    if (CollectionUtils.isEmpty(dbData))
      return paramData; 
    Set<Long> dbIds = (Set<Long>)dbData.stream().map(DataPushMonitorPO::getInterfaceUserId).collect(Collectors.toSet());
    return (List<DataPushMonitorPO>)paramData.stream().filter(item -> !dbIds.contains(item.getInterfaceUserId())).collect(Collectors.toList());
  }
  
  public Boolean saveData(List<DataPushMonitorPO> paramData, List<DataPushMonitorPO> dbData) {
    try {
      List<Long> deleteData = getDeleteData(paramData, dbData);
      if (!CollectionUtils.isEmpty(deleteData))
        this.iMonitoringPlatformDao.batchDeleteDataPush(deleteData); 
      List<DataPushMonitorPO> insertData = getInsertData(paramData, dbData);
      if (!CollectionUtils.isEmpty(insertData))
        this.iMonitoringPlatformDao.batchInsertDataPush(insertData); 
      List<DataPushMonitorPO> updateData = getUpdateData(paramData, dbData);
      if (!CollectionUtils.isEmpty(updateData))
        updateData.forEach(this.iMonitoringPlatformDao::updateDataPushMonitorStatus); 
    } catch (Exception e) {
      e.printStackTrace();
      LogHelper.error("添加失败，错误信息为：" + e.getMessage());
      return Boolean.valueOf(false);
    } 
    return Boolean.valueOf(true);
  }
}
